/*  RNE.C - Roya Naini Emulator, V7.04                                   */
/*        - M. Nelson 3-12-94                                            */
/*        - Utilizes pointers                                            */       
/*        - Calls pre-defined functions (curson(); and cursoff();)       */     
/*        - Hitting the 'R' key causes a random effect                   */
/*        - Date/time included                                           */
/*        - Awesome new screen saver                                     */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void main(void)
  {
  int timeout;
  unsigned int n; 
  char bar[80];
  char enter;
  char choice; 
  time_t timer;

  clrscrn();
  cursoff();
  
  poscurs(5,5);
  puts(" Warning - The following program contains adult subject matter\n");
  puts("\t\tthat may be objectionable to some of my end users.\n");
  puts("\t\tUser discretion is advised.\n");
  puts("\n\n\n\n\n\n\n\n\t\t\t   Press Enter to continue... ");
  enter = getch();
  if(enter != '\x0D') { clrscrn(); curson(); exit(0); }
  
  poscurs(5,2);
  printf(" Disclaimer - Prolonged abuse of the following program ");
  puts("may cause   \n");
  puts("\t\taltered vision, muscle twitching, mental confusion, and/or  \n");
  puts("\t\tpermanent brain damage.  Consult a physician if any of      \n");
  puts("\t\tthese syptoms occur.  Nelson Development may not be held    \n");
  puts("\t\tliable.  User discretion is advised.\n");
  enter = getch();
  clrscrn();
  if(enter != '\x0D') { curson(); exit(0); }
  
recall:  

  for(n = 2; n <= 22; n++)        
    { 
    poscurs(n,1);  printf("");  
    poscurs(n,79); printf("");  
    }
  for(n = 0; n <= 76; n++) bar[n] = '';        
  poscurs(1,1);  printf("%s", bar);
  poscurs(3,1);  printf("%s", bar);
  poscurs(21,1); printf("%s", bar);
  poscurs(23,1); printf("%s", bar);
  
  poscurs(2,19);
  printf("Roya Naini Emulator, V7.04  By Mike Nelson");
  poscurs(18,30);
  printf("Press escape to exit.");
  poscurs(16,23);
  printf("Press 'R' for random brain decay...");
  poscurs(9,22);
  printf("Type a number for your enjoyment -");
  
  n = 0;

  while(1)
    {
    fflush(stdin);
    poscurs(22,28);
    time(&timer);
    printf("%s", ctime(&timer));
    poscurs(9,57);
    timeout++;
    if(timeout > 10000) 
      {
      screensave();
      timeout = 0;
      goto recall;
      }
    
    if(kbhit() != 0) 
      {
      timeout = 0;
      poscurs(9,57);
      choice = getch();
      switch(choice)
    
      if(choice == 'R' || choice == 'r') 
        {
        n = rand();                       /* Generates a random number */
        n %= 10;                          /* from -32678 to 32767      */
        n += 48;
        choice = n;
        }

      switch(choice)
        {         
        case '1'    : line(&choice);
                      printf("             what the hell.            ");
                      break;
        case '2'    : line(&choice);
                      printf("            ack. oop. thbbt.           ");
                      break;
        case '3'    : line(&choice);
                      printf("             i love r.e.m.!            ");
                      break;
        case '4'    : line(&choice);
                      printf("                i care.                ");
                      break;
        case '5'    : line(&choice);
                      printf("                  yay.                 ");
                      break;
        case '6'    : line(&choice);
                      printf("               I'M BORED.              ");
                      break;
        case '7'    : line(&choice);
                      printf("    please someone, call me!! auugh!!  ");
                      break;
        case '8'    : line(&choice);
                      printf("           color me confused.          ");
                      break;
        case '9'    : line(&choice);
                      printf("               i'm lost.               ");
                      break;
        case '0'    : line(&choice);
                      printf("                HEL-lo!                ");
                      break;
        case '\x1B' : clrscrn();
                      curson();
                      exit(0);
        }           
      }
    } 
  }

void line(char *choice)
  {
  poscurs(9, 57);
  printf(" %d  ", atoi(choice));
  poscurs(12,20);
  }

void screensave(void)
  {
  int x;
  int y;                                /* poscurs variables */
  char end;

  clrscrn();
  cursoff();
  while(1)
    {
    x=rand()%80;
    if(x>70) y=rand()%25;
      else y=rand()%24;
    poscurs(y,x);
    if(x>62 || x<18) puts("roya");
      else if(y>13 || y<7) puts("roya");
        else puts("ROYA");
    if(kbhit() != 0) 
      {
      end = getch();
      clrscrn();
      break;
      }
    }
  }
